"""

    Module: $RCSfile: TestSyntax.py,v $
    Author: $Author: payne $
    Date:   $Date: 2002/06/07 03:10:07 $
    
Copyright (C) 2002 Association of Universities for Research in
Astronomy (AURA).  See LICENSE.txt for the usual disclaimers.

"""
__version__ = '$Revision: 1.5 $'[11:-2]

import sys
sys.path.insert(0,'..')

import unittest
import LDAPSyntax

class testSyntax(unittest.TestCase):

    def setUp(self):
        self.OID = '1.3.6.1.4.1.1466.115.121.1.24'
        self.Name = 'GeneralizedTime'
        
    def test01(self):
        """ 01 LDAPSyntax: testing isValidOID with valid OID """
        self.failUnless(LDAPSyntax.isValidOID(self.OID))

    def test02(self):
        """ 02 LDAPSyntax: testing isValidOID with invalid OID """
        self.failIf(LDAPSyntax.isValidOID('1.3.6.1.4.1.1.115.121.1.24'))

    def test03(self):
        """ 03 LDAPSyntax: testing getNameFromOID """
        self.failUnless(LDAPSyntax.getNameFromOID(self.OID) == self.Name)

    def test04(self):
        """ 04 LDAPSyntax: testing getOIDFromName """
        self.failUnless(LDAPSyntax.getOIDFromName(self.Name) == self.OID)

    def test05(self):
        """ 05 LDAPSyntax: testing getCanonicalName """
        self.failUnless(LDAPSyntax.getCanonicalName('GENERALIZEDTIME') == self.Name)

    def test06(self):
        """ 06 LDAPSyntax: testing validity of OID's with {nnn} on the end """
        OID = "1.3.6.1.4.1.1466.115.121.1.15{256}"
        self.failUnless(LDAPSyntax.isValidOID(OID))

    def test07(self):
        """ 07 LDAPSyntax: testing name of OID's with {nnn} on the end """
        OID = "1.3.6.1.4.1.1466.115.121.1.15{256}"
        self.failUnless(LDAPSyntax.getNameFromOID(OID) == "DirectoryString")

if __name__ == '__main__':
    
    tests = unittest.makeSuite(testSyntax, 'test')
    unittest.TextTestRunner(verbosity=2).run(tests)
